#include <Servo.h>
//моторы
//правый
#define motr_1 2    //первый пин
#define motr_2 4    //второй пин
//левый
#define motl_1 6    //первый пин
#define motl_2 8    //второй пин
//кнопка
#define button A1
//серво
Servo wheels;       //пассивные колеса
Servo grab_front;    //подъемник передний
Servo close_front;   //передняя закрывашка
Servo grab_back;   //подъемник передний
Servo close_back;   //задняя закрывашка
//пины датчиков
#define sensor_fr A9
#define sensor_fl A7
#define sensor_br A8
#define sensor_bl A6

//датчики на черном и белом
float d_fr_max = 910;
float d_fr_min = 270;

float d_fl_max = 920;
float d_fl_min = 300;

float d_bl_max = 875;
float d_bl_min = 320;

float d_br_max = 820;
float d_br_min = 275;


volatile long encL = 0;
volatile long encR = 0;

void enc1() {
  encL++;
}
void enc2() {
  encR++;
}
void setup() {
  void setup() {
    Serial.begin(9600);

    wheels.attach(3);
    grab_front.attach(5);
    close_front.attach(9);
    grab_back.attach(7);
    close_back.attach(11);

    //пинмоды
    //моторы
    pinMode(2, OUTPUT);
    pinMode(4, OUTPUT);
    pinMode(6, OUTPUT);
    pinMode(8, OUTPUT);
    pinMode(22, OUTPUT);          //реле
    pinMode(A1, INPUT_PULLUP);    //кнопка
    pinMode(A0, OUTPUT);          //синий светодиод
    pinMode(A2, OUTPUT);
    pinMode(A3, INPUT);           //датчик расстояния


    attachInterrupt(4, enc1, FALLING);
    attachInterrupt(5, enc2, FALLING);
    digitalWrite(A2, 1);
    while (digitalRead(button) == 1);
    digitalWrite(22, 1); //активация реле
    grab_front.write(50);
    grab_back.write(60);
    close_front.write(120);
    close_back.write(120);
    wheels.write(117);
    delay(2000);

    //видео
    per(1, 150);
    turn("right");
    per(2, 150);
    turn("right");
    delay(500);
    pandus_pipe();
    MoveSync(-70, 70, 200, 0);
    turn("right_b");
    delay(500);
    per(6, -150);
    back_cargo1();
    per(2, 150);
    turn("left");
    per(3, -150);
    turn("right");
    per(2, -150);
    turn("left");
    per(2, -150);
    turn("left");
    per(1, 150);
    turn("left");
    delay(200);
    back_cargo2();
    per(1, 100);
    turn("left");
    per(5, 150);
    turn("right");
    decargo();


  }

}
void MoveSync(float m1, float m2, long enc, int s) {
  
  float e = 0;
  float eold = 0;
  encL = 0;
  encR = 0;
  float deg = (encL + encR) / 2;
  while ( deg < enc) {
    if (m1 != 0 and m2 != 0) {
      if (abs(m1) > abs(m2)) {
        deg = encL;
        e = encL - encR * abs(m1) / abs(m2);
      }
      else {
        deg = encR;
        e = encL * abs(m2) / abs(m1) - encR ;
      }
      float u = e * 1 + (e - eold) * 10;
      float m11 = m1 - u * m1 / abs(m1);
      float m22 = m2 + u * m2 / abs(m2);
      move(m11, m22);
      eold = e;
    }
    else {
      move(m1, m2);
      if (m1 != 0) deg = encL;
      if (m2 != 0) deg = encR;
    }
  }

  if (s == 1) {
    move(-255 * m1 / abs(m1), -255 * m2 / abs(m2));
    delay(40);
    move(0, 0);
    delay(200);
  }
}
void PID_X(float sp, float kp, float ki, float kd, int acc, int stop) {
  float speed = abs(sp);
  float kii = ki;
  float kdd = kd;
  float kpp = kp;
  float timer = millis();
  int err_i = 0;
  float sum = 0;
  float errors[10] = {0};
  if (acc == 1) {
    kii = ki / 2;
    kpp = kp / 2;
    kdd = kd / 2;
  }
  float d1 = 255;
  float d2 = 255;
  //ПИД регулятор
  digitalWrite(A0, 1);
  while (d1 > 50 or d2 > 50) {
    if (acc == 1) {
      speed = (40 + (abs(sp) - 40) * (float(millis()) - timer) / 2000);
      if (speed >= abs(sp)) {
        speed = abs(sp);
        kii = ki;
        kpp = kp;
        kdd = kd;
        acc = 0;
      }
    }
    if (sp > 0) {
      d1 = mapp(1);
      d2 = mapp(0);
    }
    if (sp < 0) {
      d1 = mapp(2);
      d2 = mapp(3);
    }
    float e = d2 - d1;
    if (abs(e) < 20) {
      e = 0;
    }

    errors[err_i] = e;
    err_i = (err_i + 1) % 10;
    sum = sum + e - errors[err_i];
    float Up = e * kpp;
    float Ud = (e - errors[err_i]) * kdd;
    float Ui = sum * kii;

    float U = Up + Ui + Ud;

    float m1 = (speed - U) ;
    float m2 = (speed + U) ;
    if (m1 < 0) m1 = 0;
    if (m2 < 0) m2 = 0;
    if (m1 > abs(sp)) m1 = abs(sp);
    if (m2 > abs(sp)) m2 = abs(sp);
    move(m1 * sp / abs(sp), m2 * sp / abs(sp));
  }



  if (stop == 1) {
    if (sp > 0) {
      move(-255 , -255 );
      delay(40);
      move(0, 0);
      delay(200);
    }

    else {
      move(255 , 255 );
      delay(40);
      move(0, 0);
      delay(200);
    }
  }
  digitalWrite(A0, 0);
}

void PID_ENC(float sp, float kp, float ki, float kd, int acc, int stop, float enc) {
  float speed = abs(sp);
  float kii = ki;
  float kdd = kd;
  float kpp = kp;
  float timer = millis();
  int err_i = 0;
  float sum = 0;
  float errors[10] = {0};
  if (acc == 1) {
    kii = ki / 2;
    kpp = kp / 2;
    kdd = kd / 2;
  }
  float d1 = 255;
  float d2 = 255;
  encL = 0;
  encR = 0;
  while ((encL + encR) / 2 < enc) {
    if (acc == 1) {
      speed = (80 + (abs(sp) - 80) * (float(millis()) - timer) / 2000);
      if (speed >= abs(sp)) {
        speed = abs(sp);
        kii = ki;
        kpp = kp;
        kdd = kd;
        acc = 0;
      }
    }
    if (sp > 0) {
      d1 = mapp(1);
      d2 = mapp(0);
    }
    if (sp < 0) {
      d1 = mapp(2);
      d2 = mapp(3);
    }
    float e = d2 - d1;
    if (abs(e) < 20) {
      e = 0;
    }

    errors[err_i] = e;
    err_i = (err_i + 1) % 10;
    sum = sum + e - errors[err_i];
    float Up = e * kpp;
    float Ud = (e - errors[err_i]) * kdd;
    float Ui = sum * kii;

    float U = Up + Ui + Ud;

    float m1 = (speed - U) ;
    float m2 = (speed + U) ;
    if (m1 < 0) m1 = 0;
    if (m2 < 0) m2 = 0;
    if (m1 > abs(sp)) m1 = abs(sp);
    if (m2 > abs(sp)) m2 = abs(sp);
    move(m1 * sp / abs(sp), m2 * sp / abs(sp));
  }

  if (stop == 1) {
    if (sp > 0) {
      move(-255 , -255 );
      delay(40);
      move(0, 0);
      delay(200);
    }

    else {
      move(255 , 255 );
      delay(40);
      move(0, 0);
      delay(200);
    }
  }
}

void front_decargo() {
  
    PID_X(70, 0.6, 0.06, 6, 1, 0);
    PID_ENC(60, 0.6, 0.06, 6, 0, 1, 250);
    grab_front.write(100);
    delay(200);
    close_front.write(0);
    delay(1500);
    per(1, -100);
}
void back_decargo1() {
 
  PID_X(-70, 0.6, 0.06, 6, 1, 1);
  PID_ENC(70, 0.8, 0.08, 8, 1, 1, 100);
  delay(500);
  grab_back.write(110);
  delay(200);
  close_back.write(55);
  delay(500);
  PID_ENC(70, 0.4, 0.04, 4, 1, 1, 475);
  delay(200);
  close_back.write(120);
  grab_back.write(60);
  delay(100);
  per(1, 80);
}
void back_decargo2() {
  
  PID_X(-60, 0.6, 0.06, 6, 1, 0);
  PID_ENC(-60, 0.8, 0.08, 8, 0, 1, 300);
  delay(500);
  grab_back.write(105);
  delay(200);
  close_back.write(0);
  delay(500);
  PID_ENC(70, 0.4, 0.04, 4, 1, 1, 850);
}
void decargo(){
  front_decargo();
  turn("left");
  per(1, 80);
  turn("left");
  back_decargo1();
  turn("left");
  per(1, -100);
  turn("right");
  back_decargo2();
}
void PID_Sensor(float sp, float kp, float ki, float kd, int acc, int stop) {
  float speed = abs(sp);
  float kii = ki;
  float kdd = kd;
  float kpp = kp;
  uint32_t timer = millis();
  int err_i = 0;
  float sum = 0;
  float errors[10] = {0};
  if (acc == 1) {
    kii = ki / 2;
    kpp = kp / 2;
    kdd = kd / 2;
  }

  float d1 = 100;
  float d2 = 100;
  encL = 0;
  encR = 0;
  //ПИД регулятор 
  int n = 0;

  while (n < 10) {
    if (analogRead(A5) > 230) n++;
    if (acc == 1) {
      speed = (60 + (abs(sp) - 60) * (float(millis()) - timer) / 2000);
      if (speed >= abs(sp)) {
        speed = abs(sp);
        kii = ki;
        kpp = kp;
        kdd = kd;
        acc = 0;
      }
    }
    if (sp > 0) {
      d1 = mapp(1);
      d2 = mapp(0);
    }
    if (sp < 0) {
      d1 = mapp(2);
      d2 = mapp(3);
    }
    float e = d2 - d1;
    if (abs(e) < 20) {
      e = 0;
    }

    errors[err_i] = e;
    err_i = (err_i + 1) % 10;
    sum = sum + e - errors[err_i];
    float Up = e * kpp;
    float Ud = (e - errors[err_i]) * kdd;
    float Ui = sum * kii;

    float U = Up + Ui + Ud;

    float m1 = (speed - U) ;
    float m2 = (speed + U) ;
    if (m1 < 0) m1 = 0;
    if (m2 < 0) m2 = 0;
    if (m1 > abs(sp)) m1 = abs(sp);
    if (m2 > abs(sp)) m2 = abs(sp);
    move(m1 * sp / abs(sp), m2 * sp / abs(sp));
  }

  if (stop == 1) {
    if (sp > 0) {
      move(-255 , -255 );
      delay(30);
      move(0, 0);
      delay(200);
    }

    else {
      move(255 , 255 );
      delay(40);
      move(0, 0);
      delay(200);
    }
    digitalWrite(A0, 0);
  }
}
void grabbing() {
  grab_front.write(100);
  close_front.write(10);
  delay(500);
  PID_Sensor(150, 0.4, 0.01, 4, 1, 1);
  delay(500);
  close_front.write(100);
  grab_front.write(60);
}
void move(float m_r, float m_l){
  m_r = constrain(m_r, -255, 255);
  m_l = constrain(m_l, -255, 255);
//передний правый - направление
  if(m_r > 0){
    analogWrite(motr_1, m_r);
    digitalWrite(motr_2, 0);
  }
  else{
    digitalWrite(motr_1, 0);
    analogWrite(motr_2, abs(m_r));
  }

//передний левый - направление
  if(m_l > 0){
    analogWrite(motl_1, m_l);
    digitalWrite(motl_2, 0);
  }
  else{
    digitalWrite(motl_1, 0);
    analogWrite(motl_2, abs(m_l));
  }
  

}
void pandus_pipe() {
  grab_front.write(100);
  close_front.write(10);
  delay(500);
  PID_ENC(80, 0.8, 0.08, 8, 1, 0, 100);
  wheels.write(70);
  PID_ENC(120, 0.8, 0.08, 8, 0, 0, 1000);
  wheels.write(115);
  PID_ENC(120, 0.8, 0.08, 8, 0, 0, 1000);
  PID_Sensor(80, 0.8, 0.08, 8, 0, 1);
  delay(500);
  close_front.write(100);
  grab_front.write(60);
  delay(500);
  PID_ENC(-70, 0.8, 0.08, 8, 1, 0, 1200);
  PID_ENC(-50, 0.8, 0.08, 8, 0, 1, 2200);
  delay(1000);
  MoveSync(-100, -100, 150, 1);
  delay(500);
}
void per(int cross, float s) {
  if (cross == 1) {
    PID_X(s, 0.8, 0.06, 8, 1, 0);
    PID_ENC(s, 0.8, 0.06, 8, 0, 1, 270);
  }
  if (cross == 2) {
    PID_X(s, 0.8, 0.06, 8, 1, 0);
    PID_ENC(s, 0.8, 0.06, 8, 0, 0, 150);
    PID_X(s, 0.8, 0.06, 8, 0, 0);
    PID_ENC(s, 0.8, 0.06, 8, 0, 1, 270);
  }
  if (cross > 2) {
    PID_X(s, 0.8, 0.06, 8, 1, 0);
    PID_ENC(s, 0.8, 0.06, 8, 0, 0, 150);
    for (int i = 0; i < cross - 2; i++) {
      PID_X(s, 0.8, 0.06, 8, 0, 0);
      PID_ENC(s, 0.8, 0.06, 8, 0, 0, 150);
    }
    PID_X(s, 0.8, 0.06, 8, 0, 0);
    PID_ENC(s, 0.8, 0.06, 8, 0, 1, 270);
  }
}
void sensors() {
  //переменные вывода значений
  int d_fr = analogRead(sensor_fr);
  int d_fl = analogRead(sensor_fl);
  int d_bl = analogRead(sensor_bl);
  int d_br = analogRead(sensor_br);
  //вывод в монитор порта
  Serial.print("encl - "); Serial.print(encL);
  Serial.print("   encr - "); Serial.print(encR);
  Serial.print("   sensor_fr - "); Serial.print(d_fr);
  Serial.print("   sensor_fl - "); Serial.print(d_fl);
  Serial.print("   sensor_bl - "); Serial.print(d_bl);
  Serial.print("   sensor_br - "); Serial.println(d_br);
}
void sensors_Mapp() {

  int d_fr = mapp(0);
  int d_fl = mapp(1);
  int d_bl = mapp(2);
  int d_br = mapp(3);
  //
  Serial.print("sensor_fr - "); Serial.print(d_fr);
  Serial.print("   sensor_fl - "); Serial.print(d_fl);
  Serial.print("   sensor_bl - "); Serial.print(d_bl);
  Serial.print("   sensor_br - "); Serial.println(d_br);

}

float mapp(int d) {
  float out = 0;
  if (d == 0) out = (float(analogRead(sensor_fr) - d_fr_min)) / (d_fr_max - d_fr_min) * 255;

  if (d == 1) out = (float(analogRead(sensor_fl) - d_fl_min)) / (d_fl_max - d_fl_min) * 255;

  if (d == 2) out = (float(analogRead(sensor_bl) - d_bl_min)) / (d_bl_max - d_bl_min) * 255;

  if (d == 3) out = (float(analogRead(sensor_br) - d_br_min)) / (d_br_max - d_br_min) * 255;

  if (out < 0) out = 0;
  if (out > 255) out = 255;

  return out;

}
void back_cargo1(){
  wheels.write(115);
  delay(200);
  grab_back.write(105);
  close_back.write(40);
  delay(500);
  PID_ENC(-100, 0.4, 0.04, 4, 1, 1, 800);
  delay(500);
  close_back.write(115);
  delay(200);
  grab_back.write(70);
  delay(500);
  per(1,150);
  
}
void back_cargo2(){
  wheels.write(115);
  grab_back.write(105);
  close_back.write(70);
  delay(500);
  PID_ENC(-70, 0.8, 0.08, 8, 1, 1, 600);
  delay(500);
  close_back.write(120);
  delay(200);
  grab_back.write(60);
  delay(500);
  per(1,100);
}
void turn(String t_type) {
  if (t_type == "left") {
    MoveSync(-150, 150, 750,1);
    digitalWrite(A0, 1);
    delay(500);
    digitalWrite(A0, 0);
  }
  if (t_type == "right") {
    MoveSync(150, -150, 750,1); 
    digitalWrite(A0, 1);
    delay(500);
    digitalWrite(A0, 0);
  }
  if (t_type == "right_b") {
    move(-70, 70);
    while (mapp(2) < 50);
    delay(400);
    while (mapp(2) > 100);
     move(255, -255);
         delay(20);
    move(0, 0);
  }
}
void loop() {

}